#
# Conditional build:
%bcond_without	tests	# test target
%bcond_without	doc	# documentation
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module

%define	module	M2Crypto

Summary:	Python interface to OpenSSL
Summary(pl.UTF-8):	Interfejs Pythona do OpenSSL
Name:		python-M2Crypto
Version:	0.40.1
Release:	1
License:	BSD-like
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/m2crypto/
Source0:	https://files.pythonhosted.org/packages/source/M/M2Crypto/M2Crypto-%{version}.tar.gz
# Source0-md5:	280c20072afbe7010cf9e9620ea25c7b
URL:		https://gitlab.com/m2crypto/m2crypto
BuildRequires:	openssl-devel >= 1.0.1e
%if %{with python2}
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.5
BuildRequires:	python3-modules >= 1:3.5
BuildRequires:	python3-setuptools
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	swig-python >= 4.0
Requires:	openssl >= 1.0.1e
Requires:	python-modules >= 1:2.7
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
M2Crypto makes accessible to the Python programmer the following:
- DH, RSA, DSA, symmetric ciphers, message digests, HMACs.
- SSL functionality to implement clients and servers.
- S/MIME v2.

M2Crypto is released under a very liberal BSD-like licence. See
LICENCE for details.

%description -l pl.UTF-8
M2Crypto udostępnia z poziomu Pythona następujące funkcje:
- DH, RSA, DSA, szyfry symetryczne, skróty, HMAC
- SSL do implementacji klientów i serwerów
- S/MIME v2.

M2Crypto jest wydane na bardzo liberalnej licencji BSD - szczegóły w
pliku LICENCE.

%package -n python3-%{module}
Summary:	Python interface to OpenSSL
Summary(pl.UTF-8):	Interfejs Pythona do OpenSSL
Group:		Libraries/Python
Requires:	openssl >= 1.0.1e
Requires:	python3-modules >= 1:3.5

%description -n python3-%{module}
M2Crypto makes accessible to the Python programmer the following:
- DH, RSA, DSA, symmetric ciphers, message digests, HMACs.
- SSL functionality to implement clients and servers.
- S/MIME v2.

M2Crypto is released under a very liberal BSD-like licence. See
LICENCE for details.

%description -n python3-%{module} -l pl.UTF-8
M2Crypto udostępnia z poziomu Pythona następujące funkcje:
- DH, RSA, DSA, szyfry symetryczne, skróty, HMAC
- SSL do implementacji klientów i serwerów
- S/MIME v2.

M2Crypto jest wydane na bardzo liberalnej licencji BSD - szczegóły w
pliku LICENCE.

%package apidocs
Summary:	API documentation for Python M2Crypto module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona M2Crypto
Group:		Documentation

%description apidocs
API documentation for Python M2Crypto module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona M2Crypto.

%prep
%setup -q -n M2Crypto-%{version}

# test_verify_with_static_callback has some problems with multiple calls to SMIME.verify() with openssl 3.2.0
%{__sed} -i -e '/    def test_verify_with_static_callback/ i\
    @unittest.skip("fails with openssl 3.2.0")
' tests/test_smime.py

%build
%if %{with python2}
%py_build %{?with_tests:test}
%endif

%if %{with python3}
%py3_build %{?with_tests:test}
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CHANGES LICENCE README.rst
%dir %{py_sitedir}/M2Crypto
%attr(755,root,root) %{py_sitedir}/M2Crypto/_m2crypto.so
%{py_sitedir}/M2Crypto/*.py[co]
%dir %{py_sitedir}/M2Crypto/SSL
%{py_sitedir}/M2Crypto/SSL/*.py[co]
%{py_sitedir}/M2Crypto-*.egg-info
%endif

%if %{with python3}
%files -n python3-%{module}
%defattr(644,root,root,755)
%doc CHANGES LICENCE README.rst
%dir %{py3_sitedir}/%{module}
%{py3_sitedir}/%{module}/*.py
%attr(755,root,root) %{py3_sitedir}/%{module}/*.so
%{py3_sitedir}/%{module}/__pycache__
%dir %{py3_sitedir}/%{module}/SSL
%{py3_sitedir}/%{module}/SSL/*.py
%{py3_sitedir}/%{module}/SSL/__pycache__
%{py3_sitedir}/%{module}-%{version}-py*.egg-info
%endif

%files apidocs
%defattr(644,root,root,755)
%doc doc/html/{_modules,_static,*.html,*.js}
%changelog
* Mon Jan 01 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-M2Crypto.git;a=log;h=master

* Mon Jan 01 2024 Jakub Bogusz <qboosh@pld-linux.org> 1f3ef38
- disable test failing with openssl 3.2.0

* Thu Oct 26 2023 Jakub Bogusz <qboosh@pld-linux.org> 6d9b5ac
- updated to 0.40.1; no more failing tests on i686

* Tue Oct 24 2023 Jakub Bogusz <qboosh@pld-linux.org> 1581eb3
- updated to 0.40.0

* Thu Apr 28 2022 Jakub Bogusz <qboosh@pld-linux.org> 0917a23
- updated dependencies, added -apidocs (already prebuilt in sdist)

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 8bfe07a
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 54c1520
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 862d34a
- rebuild with python 3.10

* Wed Oct 13 2021 Jan Rękorajski <baggins@pld-linux.org> 183127c
- up to 0.38.0

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> 1f53387
- release 5 (by relup.sh)

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 1ccac09
- rebuild with python 3.8
- release 4 (by relup.sh)

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 0e7c484
- release 3 (by relup.sh)

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> acf9ef4
- python 3.7 rebuild
- release 2 (by relup.sh)

* Thu May 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1ddc714
- up to 0.30.1; add python3 package

* Sun Oct 29 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> cb38e23
- up to 0.27.0

* Sat Mar 26 2016 Jakub Bogusz <qboosh@pld-linux.org> c2789b2
- updated to 0.24.0

* Sat Mar 05 2016 Elan Ruusamäe <glen@delfi.ee> b3683a1
- openssl 1.0.2g rebuild
- release 2 (by relup.sh)

* Wed Jan 20 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 085d730
- up to 0.22.5

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> cf5fa81
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> c4d91c5
- release 3 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 35ec8f2
- automatic change: use py_build/py_install macros

